<template>
  <div class="image-list-managing">
    <div class="btn-toolbar" role="toolbar">
      <div class="btn-group me-2 mb-2" role="group">
        <button type="button" class="btn btn-primary" :disabled="itemActionsDisabled" @click="onClickEditImage">
          <i class="bi bi-pencil-fill"></i>
          Edit
        </button>
      </div>
      <div class="btn-group me-2 mb-2" role="group">
        <button
          type="button"
          class="btn btn-primary dropdown-toggle"
          data-bs-toggle="dropdown"
          aria-haspopup="true"
          aria-expanded="false"
          :disabled="multiSelectDisabled"
        >
          Select...
        </button>
        <div class="dropdown-menu">
          <a class="dropdown-item" href="#" @click="onClickSelectAll">
            <i class="bi bi-check-square"></i>
            All
          </a>
          <a class="dropdown-item" href="#" @click="onClickSelectNone">
            <i class="bi bi-square"></i>
            None
          </a>
          <a class="dropdown-item" href="#" @click="onClickSelectInverse">
            <i class="bi bi-arrow-left-right"></i>
            Inverse
          </a>
        </div>
      </div>
      <div class="btn-group me-2 mb-2" role="group">
        <button
          type="button"
          class="btn btn-primary dropdown-toggle"
          data-bs-toggle="dropdown"
          aria-haspopup="true"
          aria-expanded="false"
          :disabled="itemActionsDisabled"
        >
          Set as...
        </button>
        <div class="dropdown-menu">
          <a class="dropdown-item" href="#" @click="onClickSetAvatar">
            <i class="bi bi-person-fill"></i>
            Your avatar
          </a>
          <a class="dropdown-item" href="#" @click="onClickSetAlbumCover">
            <i class="bi bi-images"></i>
            The album cover
          </a>
        </div>
      </div>
      <div class="btn-group me-2 mb-2" role="group">
        <button
          type="button"
          class="btn btn-primary dropdown-toggle"
          data-bs-toggle="dropdown"
          aria-haspopup="true"
          aria-expanded="false"
          :disabled="listActionsDisabled || otherAlbums.length === 0"
        >
          Move to...
        </button>
        <div class="dropdown-menu">
          <a
            class="dropdown-item"
            v-for="album in otherAlbums"
            :key="album.id"
            href="#"
            @click="onClickMoveSelected(album.id)"
          >
            <i class="bi bi-arrow-right"></i>
            {{ album.displayName }}
          </a>
        </div>
      </div>
      <div class="btn-group mb-2" role="group">
        <button type="button" class="btn btn-danger" :disabled="listActionsDisabled" @click="onClickDeleteSelected">
          <i class="bi bi-trash-fill"></i>
          Delete
        </button>
      </div>
    </div>
  </div>
</template>

<script>
import { computed } from 'vue'
import { useStore } from 'vuex'

export default {
  name: 'ImageListManaging',
  emits: ['button'],
  props: {
    albums: { type: Array, required: true },
    alias: { type: String, required: true },
  },
  setup(props, context) {
    const store = useStore()

    const selectedImageIds = computed(() => {
      return store.state.gallery.selectedImages.map((i) => i.id)
    })

    const firstSelectedImageId = computed(() => {
      return store.state.gallery.selectedImages.length !== 0 ? store.state.gallery.selectedImages[0].id : ''
    })

    const itemActionsDisabled = computed(() => {
      return store.state.gallery.selectedImages.length !== 1
    })

    const listActionsDisabled = computed(() => {
      return store.state.gallery.selectedImages.length === 0
    })

    const multiSelectDisabled = computed(() => {
      return Boolean(store.state.gallery.formName) && !store.state.gallery.multiSelect
    })

    const otherAlbums = computed(() => {
      return props.albums.filter((a) => a.alias !== props.alias)
    })

    const onClickEditImage = () => {
      context.emit('button', 'edit-image', { imageId: firstSelectedImageId.value })
    }

    const onClickSelectAll = () => {
      context.emit('button', 'select-all')
    }

    const onClickSelectNone = () => {
      context.emit('button', 'select-none')
    }

    const onClickSelectInverse = () => {
      context.emit('button', 'select-inverse')
    }

    const onClickSetAvatar = () => {
      context.emit('button', 'set-avatar', { imageId: firstSelectedImageId.value })
    }

    const onClickSetAlbumCover = () => {
      context.emit('button', 'set-album-cover', {
        imageId: firstSelectedImageId.value,
      })
    }

    const onClickMoveSelected = (albumId) => {
      context.emit('button', 'move-selected', {
        imageIds: selectedImageIds.value,
        albumId: albumId,
      })
    }

    const onClickDeleteSelected = () => {
      context.emit('button', 'delete-selected', {
        imageIds: selectedImageIds.value,
      })
    }

    return {
      firstSelectedImageId,
      itemActionsDisabled,
      listActionsDisabled,
      multiSelectDisabled,
      otherAlbums,
      onClickEditImage,
      onClickSelectAll,
      onClickSelectNone,
      onClickSelectInverse,
      onClickSetAvatar,
      onClickSetAlbumCover,
      onClickMoveSelected,
      onClickDeleteSelected,
    }
  },
}
</script>
